require 'redis'
require 'json'
require 'elasticsearch'

module Akakor
  module Indexer
    class Daemon
      def self.start
        new.start
      end

      def start
        redis = Redis.new
        es = Elasticsearch::Client.new
        while true do
          workobject = JSON.parse(redis.blpop('workobject', 0)[1])
          if workobject['F_InstrSheetName'] == "Terminate"
            es.delete index: 'workobjects_current', type: 'wob', id: workobject['F_WobNum']
          else
            es.index index: 'workobjects_current', type: 'wob', id: workobject['F_WobNum'], body: workobject
          end
          es.index index: 'workobjects_history', type: 'wob', body: workobject
        end
      end
    end
  end
end
